#	Programmer:	Daniel Pozmanter
#	E-mail:		drpython@bluebottle.com
#	Note:		You must reply to the verification e-mail to get through.
#
#	Copyright 2003-2005 Daniel Pozmanter
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#	DrPython is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
#Go To Source Browser

import re, string
import wx
from drSingleChoiceDialog import drSingleChoiceDialog

def GetMatches(text, resourcebrowser):
	matches = []
	positions = []
		
	matcher = resourcebrowser.finditer(text)
	
	try:
		match = matcher.next()
	except:
		match = None
	while (match is not None):
		matches.append(match.group().replace('\t', '    '))
		positions.append(match.start())
		try:
			match = matcher.next()
		except:
			match = None
		
	return matches, positions
		
def SourceBrowserGoTo(frame, Document):
	compchar = Document.GetIndentationCharacter()
	resourcebrowser = re.compile(r'(^'+compchar+'*?class\s.*:)|(^'+compchar+'*?def\s.*:)|(^'+compchar+'*?import\s.*$)|(^'+compchar+'*?from\s.*$)', re.MULTILINE)	
	text = Document.GetText()
	
	matches, positions = GetMatches(text, resourcebrowser)
	
	d = drSingleChoiceDialog(frame, 'Source Browser Go To', matches, False)
	answer = d.ShowModal()
	d.Destroy()

	if (answer == wx.ID_OK):
		i = d.GetSelection()
		line = Document.LineFromPosition(positions[i])
		Document.ScrollToLine(line)
		Document.GotoLine(line)
		Document.GotoPos(positions[i])
	
	Document.SetFocus()	
	Document.SetSTCFocus(True)
	